import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { RecordHandlerProgressInput, RecordHandlerProgressOutput } from "../models/models_0";
import { deserializeAws_queryRecordHandlerProgressCommand, serializeAws_queryRecordHandlerProgressCommand, } from "../protocols/Aws_query";
var RecordHandlerProgressCommand = (function (_super) {
    __extends(RecordHandlerProgressCommand, _super);
    function RecordHandlerProgressCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    RecordHandlerProgressCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudFormationClient";
        var commandName = "RecordHandlerProgressCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: RecordHandlerProgressInput.filterSensitiveLog,
            outputFilterSensitiveLog: RecordHandlerProgressOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    RecordHandlerProgressCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryRecordHandlerProgressCommand(input, context);
    };
    RecordHandlerProgressCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryRecordHandlerProgressCommand(output, context);
    };
    return RecordHandlerProgressCommand;
}($Command));
export { RecordHandlerProgressCommand };
