import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CloudFormationClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CloudFormationClient";
import { DescribeStackSetInput, DescribeStackSetOutput } from "../models/models_0";
export interface DescribeStackSetCommandInput extends DescribeStackSetInput {
}
export interface DescribeStackSetCommandOutput extends DescribeStackSetOutput, __MetadataBearer {
}

export declare class DescribeStackSetCommand extends $Command<DescribeStackSetCommandInput, DescribeStackSetCommandOutput, CloudFormationClientResolvedConfig> {
    readonly input: DescribeStackSetCommandInput;
    constructor(input: DescribeStackSetCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CloudFormationClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DescribeStackSetCommandInput, DescribeStackSetCommandOutput>;
    private serialize;
    private deserialize;
}
